## atanks 6.0~dfsg

=== Makefile ===
VERSION=6.0
PREFIX ?= /usr/
DESTDIR ?= 
BINPREFIX = $(PREFIX)

BINDIR = ${BINPREFIX}bin/
INSTALLDIR = ${PREFIX}share/games/atanks

export VERSION
export PREFIX
export INSTALLDIR

FILENAME=atanks-${VERSION}
INSTALL=$(PREFIX)bin/install -c
DISTCOMMON=atanks/*.dat atanks/COPYING atanks/README atanks/TODO atanks/Changelog atanks/BUGS atanks/*.txt
INCOMMON=COPYING README TODO Changelog *.txt unicode.dat

all:
	FLAGS=-DLINUX $(MAKE) -C src

install: 
	mkdir -p $(DESTDIR)${BINDIR}
	$(INSTALL) -m 755 atanks $(DESTDIR)${BINDIR}
	mkdir -p $(DESTDIR)/usr/share/applications
	$(INSTALL) -m 644 atanks.desktop $(DESTDIR)/usr/share/applications
	mkdir -p $(DESTDIR)/usr/share/icons/hicolor/48x48/apps
	$(INSTALL) -m 644 atanks.png $(DESTDIR)/usr/share/icons/hicolor/48x48/apps
	mkdir -p $(DESTDIR)${INSTALLDIR}
	mkdir -p $(DESTDIR)${INSTALLDIR}/button
	mkdir -p $(DESTDIR)${INSTALLDIR}/misc
	mkdir -p $(DESTDIR)${INSTALLDIR}/missile
	mkdir -p $(DESTDIR)${INSTALLDIR}/sound
	mkdir -p $(DESTDIR)${INSTALLDIR}/stock
	mkdir -p $(DESTDIR)${INSTALLDIR}/tank
	mkdir -p $(DESTDIR)${INSTALLDIR}/tankgun
	mkdir -p $(DESTDIR)${INSTALLDIR}/title
	mkdir -p $(DESTDIR)${INSTALLDIR}/text
	$(INSTALL) -m 644 $(INCOMMON) $(DESTDIR)${INSTALLDIR}
	$(INSTALL) -m 644 button/* $(DESTDIR)${INSTALLDIR}/button
	$(INSTALL) -m 644 misc/* $(DESTDIR)${INSTALLDIR}/misc
	$(INSTALL) -m 644 missile/* $(DESTDIR)${INSTALLDIR}/missile
	$(INSTALL) -m 644 sound/* $(DESTDIR)${INSTALLDIR}/sound
	$(INSTALL) -m 644 stock/* $(DESTDIR)${INSTALLDIR}/stock
	$(INSTALL) -m 644 tank/* $(DESTDIR)${INSTALLDIR}/tank
	$(INSTALL) -m 644 tankgun/* $(DESTDIR)${INSTALLDIR}/tankgun
	$(INSTALL) -m 644 title/* $(DESTDIR)${INSTALLDIR}/title
	$(INSTALL) -m 644 text/* $(DESTDIR)${INSTALLDIR}/text

user:
	INSTALLDIR=./ FLAGS=-DLINUX $(MAKE) -C src

winuser:
	INSTALLDIR=./ FLAGS=-DWIN32 $(MAKE) -C src -f Makefile.windows

osxuser:
	INSTALLDIR=./ FLAGS="-DMACOSX" $(MAKE) -C src -f Makefile.bsd

ubuntu:
	FLAGS="-DLINUX -DUBUNTU" $(MAKE) -C src

clean:
	rm -f atanks atanks.exe
	$(MAKE) -C src clean

dist: source-dist i686-dist win32-dist

tarball: clean
	cd .. && tar czf atanks-$(VERSION).tar.gz atanks-$(VERSION)

zipfile: clean
	cd .. && zip -r atanks-$(VERSION)-source.zip atanks-$(VERSION)

source-dist:
	cd ../; \
	rm -f ${FILENAME}.tar.gz; \
	tar cvf ${FILENAME}.tar atanks/src/*.cpp atanks/src/*.h atanks/src/Makefile atanks/src/Makefile.windows atanks/Makefile ${DISTCOMMON}; \
	gzip ${FILENAME}.tar

i686-dist:
	cd ../; \
	rm -f ${FILENAME}-i686-dist.tar; \
	rm -f ${FILENAME}-i686-dist.tar.gz; \
	strip atanks/atanks; \
	tar cvf ${FILENAME}-i686-dist.tar atanks/atanks ${DISTCOMMON}; \
	gzip ${FILENAME}-i686-dist.tar;

win32-dist:
	cd ../; \
	rm -f ${FILENAME}-win32-dist.zip; \
	zip ${FILENAME}-win32-dist.zip atanks/Atanks.exe atanks/alleg40.dll ${DISTCOMMON};

=== src/Makefile ===
.PHONY: all clean veryclean

MODULES = atanks.o beam.o button.o environment.o explosion.o fade.o files.o globaldata.o \
          missile.o perlin.o physobj.o player.o satellite.o sky.o tank.o team.o teleport.o virtobj.o \
          update.o network.o floattext.o land.o text.o client.o gameloop.o

CXX?=clang++
LIB=ar
WINDRES=
# FLAGS += -DDATA_DIR=\".\" -Wno-write-strings -DNETWORK -DTHREADS
FLAGS += -DDATA_DIR=\"${INSTALLDIR}\" -DNEW_GAMELOOP -Wno-write-strings -DNETWORK -DTHREADS -pthread -Wextra -pedantic -ggdb3
OUTPUT = ../atanks
WFLAGS = 
OFLAGS = 
LFLAGS +=
LDFLAGS +=  `allegro-config --libs` -lm -lpthread

CXXFLAGS += -Wall -Iinclude # -fprofile-arcs -ftest-coverage 

SRCS  = $(MODULES:.o=.cpp)
GLOBALS	= main.h imagedefs.h externs.h

all: 	$(OUTPUT)

clean:  
	rm -f *.o

veryclean: clean
	rm $(OUTPUT)

$(MODULES): Makefile

atanks.o: atanks.cpp globals.h main.h menucontent.h
	$(CXX) -c atanks.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

button.o: button.cpp button.h
	$(CXX) -c button.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

client.o: client.h client.cpp
	$(CXX) -c client.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

environment.o: environment.cpp environment.h
	$(CXX) -c environment.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

explosion.o: explosion.cpp explosion.h
	$(CXX) -c explosion.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

files.o: files.cpp files.h text.h text.cpp
	$(CXX) -c files.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

floattext.o: floattext.cpp floattext.h
	$(CXX) -c floattext.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

gameloop.o: gameloop.cpp atanks.cpp main.h
	$(CXX) -c gameloop.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

globaldata.o: globaldata.cpp globaldata.h
	$(CXX) -c globaldata.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

land.o: land.cpp land.h globaldata.h environment.h
	$(CXX) -c land.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

missile.o: missile.cpp missile.h
	$(CXX) -c missile.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

teleport.o: teleport.cpp teleport.h
	$(CXX) -c teleport.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

physobj.o: physobj.cpp physobj.h
	$(CXX) -c physobj.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

player.o: player.cpp player.h
	$(CXX) -c player.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

tank.o: tank.cpp tank.h
	$(CXX) -c tank.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

team.o: team.cpp team.h
	$(CXX) -c team.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

virtobj.o: virtobj.cpp virtobj.h
	$(CXX) -c virtobj.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

fade.o: fade.cpp
	$(CXX) -c fade.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

perlin.o: perlin.cpp
	$(CXX) -c perlin.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

sky.o: sky.cpp sky.h
	$(CXX) -c sky.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

satellite.o: satellite.cpp satellite.h
	$(CXX) -c satellite.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

text.o: text.cpp text.h
	$(CXX) -c text.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

update.o: update.cpp update.h
	$(CXX) -c update.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

network.o: network.cpp network.h
	$(CXX) -c network.cpp -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

%.o: %.cpp %.h
	$(CXX) -c $< -o $@ $(FLAGS) $(LFLAGS) $(OFLAGS) $(CXXFLAGS)

$(OUTPUT): $(OBJECTS) $(MODULES)
	$(CXX) $(MODULES) -o $(OUTPUT) $(FLAGS) $(LFLAGS) $(LDFLAGS) $(SFLAGS) $(CXXFLAGS)
	# strip $(OUTPUT)

# dependencies:
physobj.h: main.h virtobj.h globaldata.h
virtobj.h: main.h player.h
main.h: imagedefs.h externs.h
globaldata.h: main.h
player.h: main.h menu.h
tank.h: physobj.h
floattext.h: virtobj.h main.h environment.h
menu.h: globaldata.h
environment.h: main.h tank.h
files.h: globaldata.h environment.h 
globals.h: virtobj.h floattext.h physobj.h tank.h missile.h explosion.h player.h environment.h globaldata.h teleport.h decor.h beam.h
button.h: globaldata.h environment.h
team.h: globaldata.h
satellite.h: environment.h globaldata.h virtobj.h
beam.h: main.h virtobj.h physobj.h
missile.h: main.h physobj.h
teleport.h: main.h virtobj.h
decor.h: main.h physobj.h environment.h globaldata.h
explosion.h: main.h physobj.h
virtobj.cpp: virtobj.h environment.h
physobj.cpp: physobj.h environment.h
atanks.cpp: globals.h menu.h button.h team.h files.h satellite.h menucontent.h
beam.cpp: environment.h globaldata.h physobj.h player.h decor.h tank.h beam.h
button.cpp: button.h
environment.cpp: environment.h globaldata.h virtobj.h missile.h tank.h files.h
explosion.cpp: environment.h globaldata.h explosion.h missile.h decor.h tank.h player.h
fade.cpp: globaldata.h main.h
files.cpp: player.h files.h main.h
globaldata.cpp: player.h globaldata.h files.h
missile.cpp: environment.h globaldata.h explosion.h missile.h decor.h tank.h
perlin.cpp: main.h
player.cpp: environment.h globaldata.h player.h tank.h menu.h files.h floattext.h
satellite.cpp: environment.h satellite.h beam.h
sky.cpp: globaldata.h main.h sky.h
tank.cpp: environment.h globaldata.h floattext.h explosion.h teleport.h missile.h player.h beam.h tank.h
team.cpp: tank.h team.h player.h
teleport.cpp: environment.h globaldata.h teleport.h

=== debian/changelog ===
atanks (6.0~dfsg-1) unstable; urgency=low

  * New upstream release
    - few bug fixes which should improve stability and reduce memory leakage
    - press "v" to decrease audio volume and "V" (shift+v) to increase volume

 -- Mark Purcell <msp@debian.org>  Sat, 14 Jun 2014 11:04:28 +1000

atanks (5.9~dfsg-1) unstable; urgency=low

  * New upstream release
    - Fixes "[Mayhem] Bug report on atanks: atanks crashes with exit status
    139" (Closes: #715654)

 -- Mark Purcell <msp@debian.org>  Sun, 13 Apr 2014 15:04:13 +1000

=== debian/control ===
Source: atanks
Section: games
Priority: optional
Uploaders: Mark Purcell <msp@debian.org>
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: debhelper (>= 9), liballegro-dev | liballegro4.2-dev
Homepage: http://atanks.sourceforge.net/
Vcs-Svn: svn://anonscm.debian.org/pkg-allegro/atanks/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-allegro/atanks/trunk/
Standards-Version: 3.9.4


Package: atanks
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, atanks-data (= ${source:Version})
Replaces: atanks-data(<< 5.7~dfsg-1)
Breaks: atanks-data (<< 5.7~dfsg-1)
Description: tank-battling game
 Atomic tanks is a multi-player game in which you attempt to destroy
 other tanks while trying to protect your own. You earn money for
 destroying other tanks; with this money you can buy upgrades and better
 weapons for your tank.
 .
 This game is similar Scorched Earth or the Worms series of games.

Package: atanks-data
Depends: ${misc:Depends}
Architecture: all
Description: data files for Atomic tanks
 Atomic tanks is a multi-player game in which you attempt to destroy
 other tanks while trying to protect your own. You earn money for
 destroying other tanks; with this money you can buy upgrades and better
 weapons for your tank.
 .
 This game is similar Scorched Earth or the Worms series of games.
 .
 This package holds the data files needed for Atomic tanks.

Package: atanks-dbg
Depends: ${shlibs:Depends}, ${misc:Depends}, atanks (= ${binary:Version})
Architecture: any
Section: debug
Priority: extra
Description: tank-battling game - debug symbols
 Atomic tanks is a multi-player game in which you attempt to destroy
 other tanks while trying to protect your own. You earn money for
 destroying other tanks; with this money you can buy upgrades and better
 weapons for your tank.
 .
 This package contains the debug symbols which is useful if you wish to
 analyse segmentation faults.

=== debian/rules ===
#!/usr/bin/make -f

DEBVERSION := $(shell head -n 1 debian/changelog \
                    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
UPVERSION := $(shell echo $(DEBVERSION) | sed 's/~dfsg-.//')

PKG=atanks
FILENAME := $(PKG)_$(UPVERSION)~dfsg.orig.tar.gz
UPFILENAME := $(PKG)_$(UPVERSION).orig.tar.gz
URL := http://downloads.sourceforge.net/project/$(PKG)/$(PKG)/$(PKG)-$(UPVERSION)/$(PKG)-$(UPVERSION).tar.gz

%:
	dh $@ --parallel --dbg-package=atanks-dbg

override_dh_install:
	dh_install -XCOPYING --fail-missing
	rm -fR $(CURDIR)/debian/atanks-data/usr/share/applications/

get-orig-source:
	@@dh_testdir
	@@[ -d ../tarballs/. ]||mkdir -p ../tarballs
	@@#this is for stable versions
	@@echo Downloading $(UPFILENAME) from $(URL) ...
	@@wget -nv -T10 -t3 -O ../tarballs/$(UPFILENAME) $(URL)
	@@echo 'Repacking as DFSG-free (removing windows DLLs)...'
	@@mkdir -p ../tarballs/$(PKG)-$(UPVERSION).tmp/
	@@cd ../tarballs/$(PKG)-$(UPVERSION).tmp ; tar xfz ../$(UPFILENAME)
	@@find ../tarballs/$(PKG)-$(UPVERSION).tmp/ -iname '*.dll' -delete
	@@echo Writing archive ../tarballs/$(FILENAME) ...
	@@cd ../tarballs/$(PKG)-$(UPVERSION).tmp ; tar cfz ../$(FILENAME) *
	@@echo Cleaning up...
	@@$(RM) -rf ../tarballs/$(PKG)-$(UPVERSION).tmp/ ../tarballs/$(UPFILENAME)

## atanks 6.5~dfsg

=== Makefile ===
.PHONY: all install clean veryclean user winuser osxuser ubuntu \
dist tarball zipfile source-dist i686-dist win32-dist

VERSION := 6.5


DEBUG   ?= NO
# Note: Submit as "YES" to enable debugging
# Note: If any flag starting with -g is found in the CXXFLAGS, DEBUG is
#       switched to YES no matter whether set otherwise or not.

# The following switches can be used to fine-tune the debugging output:
# Note: DEBUG_AICORE can be used to enable both DEBUG_AIMING and DEBUG_EMOTION
#       together with a single flag.
DEBUG_AICORE  ?= NO
DEBUG_AIMING  ?= NO
DEBUG_EMOTION ?= NO
DEBUG_FINANCE ?= NO
DEBUG_OBJECTS ?= NO
DEBUG_PHYSICS ?= NO

# If the debug output shall be written to atanks.log, set this to YES
DEBUG_LOG_TO_FILE ?= NO

# These three are mutually exclusive. If all are set to yes,
# address-sanitizing has priority, followed by leak, thread
# is last.
SANITIZE_ADDRESS ?= NO
SANITIZE_LEAK    ?= NO
SANITIZE_THREAD  ?= NO

# The following is only used on gcc-4.9+ and only without debugging enabled.
USE_LTO ?= NO

# ------------------------------------
# Install and target directories
# ------------------------------------
PREFIX     ?= /usr
DESTDIR    ?=
BINPREFIX  ?= $(PREFIX)
BINDIR     ?= ${BINPREFIX}/bin
INSTALLDIR ?= ${PREFIX}/share/games/atanks


# ------------------------------------
# Source files and objects
# ------------------------------------
SOURCES := $(sort $(wildcard src/*.cpp))
MODULES := $(addprefix obj/,$(notdir $(SOURCES:.cpp=.o)))
DEPENDS := $(addprefix dep/,$(notdir $(SOURCES:.cpp=.d)))


# -------------------------------------
# Platform to build for (Can be forced)
# -------------------------------------
PLATFORM ?= none
ifeq (none,$(PLATFORM))
  # The easiest way is to go through our make goals
  # I know this looks weird, but the following simply means:
  # "If the search for "win" in MAKECMDGOALS does not return an empty string"
  ifneq (,$(findstring win,$(MAKECMDGOALS)))
    PLATFORM := WIN32
  else ifneq (,$(findstring osx,$(MAKECMDGOALS)))
    PLATFORM := MACOSX
  else
    PLATFORM := LINUX
  endif
endif

# If this is a user make goal, the install directory is forced to be local:
ifneq (,$(findstring user,$(MAKECMDGOALS)))
  INSTALLDIR := .
endif


# --------------------------------------------
# Target executable and distribution file name
# --------------------------------------------
TARGET   := atanks
FILENAME := $(TARGET)-$(VERSION)


# ------------------------------------
# Tools to use
# ------------------------------------
INSTALL := $(shell which install)
RM      := $(shell which rm) -f
CXX     ?= g++
SED     := $(shell which sed)
WINDRES :=

ifeq (,$(findstring /,$(CXX)))
  CXX   := $(shell which $(CXX))
endif


# if this is a Windows target, prefer mingw32-g++ over g++
# Further more the WIN32 Platform needs windres.exe to create src/atanks.res
ifeq (WIN32,$(PLATFORM))
  ifneq (,$(findstring /g++,$(CXX)))
    CXX   := $(shell which mingw32-g++)
  endif
  WINDRES := $(shell which windres.exe)
  MODULES := ${MODULES} obj/atanks.res
  TARGET  := ${TARGET}.exe
  RM      := del /q
endif

# Use the compiler as the linker.
LD := $(CXX)

# --------------------------------------------------------------------------
# Determine proper C++11 standard flag, and if and how stack protector works
# --------------------------------------------------------------------------
GCCVERSGTEQ47 := 0
GCCVERSGTEQ49 := 0
GCCUSESGOLD   := 0
GCC_STACKPROT :=
GCC_CXXSTD    := 0x
PEDANDIC_FLAG := -pedantic

# Note: It has to be evaluated which versions of clang and mingw
#       start using c++11 instead of c++0x.
ifneq (,$(findstring /g++,$(CXX)))
  GCCVERSGTEQ47 := $(shell expr `$(CXX) -dumpversion | cut -f1,2 -d. | tr -d '.'` \>= 47)
  GCCVERSGTEQ49 := $(shell expr `$(CXX) -dumpversion | cut -f1,2 -d. | tr -d '.'` \>= 49)
endif

ifeq "$(GCCVERSGTEQ47)" "1"
  GCC_CXXSTD    := 11
  PEDANDIC_FLAG := -Wpedantic
  ifeq "$(GCCVERSGTEQ49)" "1"
    GCC_STACKPROT := -fstack-protector-strong
    GCCUSESGOLD   := $(shell ld --version | head -n 1 | grep -c "GNU gold")
  else
    GCC_STACKPROT := -fstack-protector
  endif
endif


# ------------------------------------
# Flags for compiler and linker
# ------------------------------------
CPPFLAGS += -DDATA_DIR=\"${INSTALLDIR}\" -D$(PLATFORM) -DVERSION=\"${VERSION}\"
CXXFLAGS += -Wall -Wextra $(PEDANDIC_FLAG) -std=c++$(GCC_CXXSTD)
LDFLAGS  +=

# Depending on the platform, some values have to be appended:
ifeq (MACOSX,$(PLATFORM))
  CPPFLAGS := ${CPPFLAGS} -I/usr/local/include $(shell allegro-config --cppflags)
  LDFLAGS  := ${LDFLAGS} $(shell allegro-config --libs)
else ifeq (WIN32,$(PLATFORM))
  CPPFLAGS := ${CPPFLAGS} -I/usr/local/include
  CXXFLAGS := ${CXXFLAGS} -mwindows
  LDFLAGS  := ${LDFLAGS} -mwindows -L. -lalleg44
else
  ifneq (,$(findstring bsd,$(MAKECMDGOALS)))
    C_INCLUDE_PATH     := /usr/local/include
    CPLUS_INCLUDE_PATH := /usr/local/include
    CXXFLAGS           := ${CXXFLAGS} -Wno-c99-extensions
    export C_INCLUDE_PATH
    export CPLUS_INCLUDE_PATH
  endif
  CPPFLAGS := ${CPPFLAGS} -DNETWORK $(shell allegro-config --cppflags)
  CXXFLAGS := ${CXXFLAGS} -pthread
  LDFLAGS  := ${LDFLAGS} $(shell allegro-config --libs) -lm -lpthread
endif


# If the make goal is "ubuntu", a special define is to be added:
ifeq (UBUNTU,$(MAKECMDGOALS))
  CPPFLAGS := ${CPPFLAGS} -DUBUNTU
endif


# ------------------------------------
# Debug Mode settings
# ------------------------------------
HAS_DEBUG_FLAG := NO
ifneq (,$(findstring -g,$(CXXFLAGS)))
  ifneq (,$(findstring -ggdb,$(CXXFLAGS)))
    HAS_DEBUG_FLAG := YES
  endif
  DEBUG := YES
endif

ifeq (YES,$(DEBUG))
  ifeq (NO,$(HAS_DEBUG_FLAG))
    CXXFLAGS := -ggdb ${CXXFLAGS} -O0
  endif

  CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG
  CXXFLAGS := ${CXXFLAGS} ${GCC_STACKPROT} -Wunused

  # LTO is hard blocked now:
  USE_LTO := NO

  # address / thread sanitizer activation
  ifeq (YES,$(SANITIZE_ADDRESS))
    CXXFLAGS := ${CXXFLAGS} -fsanitize=address
    LDFLAGS  := ${LDFLAGS} -fsanitize=address
  else ifeq (YES,$(SANITIZE_LEAK))
    CXXFLAGS := ${CXXFLAGS} -fsanitize=leak
    LDFLAGS  := ${LDFLAGS} -fsanitize=leak
  else ifeq (YES,$(SANITIZE_THREAD))
    CPPFLAGS := ${CPPFLAGS} -DUSE_MUTEX_INSTEAD_OF_SPINLOCK
    CXXFLAGS := ${CXXFLAGS} -fsanitize=thread -fPIC -O2 -ggdb
    LDFLAGS  := ${LDFLAGS} -fsanitize=thread -pie -O2 -ggdb
  endif

  # Add specific debug message flavours
  ifeq (YES,$(DEBUG_AICORE))
    CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG_AIMING -DATANKS_DEBUG_EMOTIONS
  endif
  ifeq (YES,$(DEBUG_AIMING))
    CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG_AIMING
  endif
  ifeq (YES,$(DEBUG_EMOTION))
    CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG_EMOTIONS
  endif
  ifeq (YES,$(DEBUG_FINANCE))
    CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG_FINANCE
  endif
  ifeq (YES,$(DEBUG_OBJECTS))
    CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG_OBJECTS
  endif
  ifeq (YES,$(DEBUG_PHYSICS))
    CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG_PHYSICS
  endif
  ifeq (YES,$(DEBUG_LOG_TO_FILE))
    CPPFLAGS := ${CPPFLAGS} -DATANKS_DEBUG_LOGTOFILE
  endif

else
  CXXFLAGS := -march=native ${CXXFLAGS} -O2
endif


# Potentially enable LTO if this is gcc-4.9 and greater
ifeq (YES,$(USE_LTO))
  ifeq "$(GCCVERSGTEQ49)" "1"
    CXXFLAGS := ${CXXFLAGS} -flto
  endif
  ifeq "$(GCCUSESGOLD)" "1"
    CXXFLAGS := ${CXXFLAGS} -fuse-linker-plugin
  endif
endif



# ------------------------------------
# Distribution file lists
# ------------------------------------
DISTCOMMON := \
atanks/*.dat atanks/COPYING atanks/README atanks/TODO \
atanks/Changelog atanks/BUGS atanks/*.txt

INCOMMON   := COPYING README TODO Changelog *.txt unicode.dat

# ------------------------------------
# Default target
# ------------------------------------

all: $(TARGET)


# ------------------------------------
# Create dependencies
# This is the standard as described
# on the GNU make info manual.
# (See Chapter 4.14)
# ------------------------------------
dep/%.d: src/%.cpp
	@set -e; $(RM) $@; \
	$(CXX) -MM $(CPPFLAGS) $(CXXFLAGS) $< > $@.$$$$; \
	$(SED) 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ > $@; \
	$(RM) $@.$$$$


# ------------------------------------
# Compile modules
# ------------------------------------
obj/%.o: src/%.cpp
	@echo "Compiling $@"
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ -c $<


# ------------------------------------
# Build windows res file
# ------------------------------------
obj/atanks.res:
ifeq (WIN32,$(PLATFORM))
	$(WINDRES) -i src/atanks.rc --input-format=rc -o obj/atanks.res -O coff
else
	@echo "This is no WIN32 platform, so why?"
endif


# ------------------------------------
# Regular targets
# ------------------------------------
install: $(TARGET)
	$(INSTALL) -d $(DESTDIR)${BINDIR}
	$(INSTALL) -m 755 atanks $(DESTDIR)${BINDIR}
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/applications
	$(INSTALL) -m 644 atanks.desktop $(DESTDIR)$(PREFIX)/share/applications
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps
	$(INSTALL) -m 644 atanks.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/button
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/misc
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/missile
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/sound
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/stock
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/tank
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/tankgun
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/title
	$(INSTALL) -d $(DESTDIR)${INSTALLDIR}/text
	$(INSTALL) -m 644 $(INCOMMON) $(DESTDIR)${INSTALLDIR}
	$(INSTALL) -m 644 button/* $(DESTDIR)${INSTALLDIR}/button
	$(INSTALL) -m 644 misc/* $(DESTDIR)${INSTALLDIR}/misc
	$(INSTALL) -m 644 missile/* $(DESTDIR)${INSTALLDIR}/missile
	$(INSTALL) -m 644 sound/* $(DESTDIR)${INSTALLDIR}/sound
	$(INSTALL) -m 644 stock/* $(DESTDIR)${INSTALLDIR}/stock
	$(INSTALL) -m 644 tank/* $(DESTDIR)${INSTALLDIR}/tank
	$(INSTALL) -m 644 tankgun/* $(DESTDIR)${INSTALLDIR}/tankgun
	$(INSTALL) -m 644 title/* $(DESTDIR)${INSTALLDIR}/title
	$(INSTALL) -m 644 text/* $(DESTDIR)${INSTALLDIR}/text

$(TARGET): $(MODULES)
	$(LD) -o $@ $(MODULES) $(CPPFLAGS) $(LDFLAGS) $(CXXFLAGS)

clean:
	$(RM) obj/* atanks

veryclean: clean
ifeq (WIN32,$(PLATFORM))
	$(RM) $(TARGET).exe
else
	$(RM) $(TARGET)
endif


# ------------------------------------
# User (local) targets
# ------------------------------------

user: $(TARGET)
winuser: $(TARGET)
osxuser: $(TARGET)
bsduser: $(TARGET)
ubuntu: $(TARGET)

# ------------------------------------
# Distribution targets
# ------------------------------------

dist: source-dist i686-dist win32-dist

tarball: veryclean
	cd .. && tar czf $(FILENAME).tar.gz $(FILENAME) --exclude=.git

zipfile: veryclean
	cd .. && zip -r $(FILENAME)-source.zip $(FILENAME) -x *.git*

source-dist: $(TARGET)
	cd ../; \
	$(RM) $(FILENAME).tar.gz; \
	tar czf $(FILENAME).tar.gz atanks/src/*.cpp atanks/src/*.h atanks/Makefile $(DISTCOMMON)

i686-dist: $(TARGET)
	cd ../; \
	$(RM) $(FILENAME)-i686-dist.tar.gz; \
	strip atanks/atanks; \
	tar czf $(FILENAME)-i686-dist.tar atanks/atanks $(DISTCOMMON)

win32-dist: $(TARGET)
	cd ../; \
	$(RM) $(FILENAME)-win32-dist.zip; \
	zip -r $(FILENAME)-win32-dist.zip atanks/atanks.exe atanks/alleg40.dll $(DISTCOMMON)

# ------------------------------------
# Include all dependency files
# ------------------------------------
ifeq (,$(findstring clean,$(MAKECMDGOALS)))
  -include $(DEPENDS)
endif

=== debian/changelog ===
atanks (6.5~dfsg-2) unstable; urgency=medium

  * Add freebsd-FTBFS.patch and fix FTBFS on kfreeBSD architectures.
    Thanks to Jesse Smith for the patch. (Closes: #845924)

 -- Markus Koschany <apo@debian.org>  Sun, 27 Nov 2016 22:40:27 +0100

atanks (6.5~dfsg-1) unstable; urgency=medium

  * New upstream version 6.5~dfsg.
    - Building Atanks is reproducible now. Thanks to Reiner Herrmann for the
      patch. (Closes: #842865)
  * Adopt the package because it was orphaned. Remove Mark Purcell from
    Uploaders. (Closes: #839966)
  * wrap-and-sort -sa.
  * Move the package to Git.
  * Add README.source.
  * Mark atanks-data Multi-Arch: foreign.

 -- Markus Koschany <apo@debian.org>  Sat, 26 Nov 2016 23:52:34 +0100

atanks (6.4~dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 6.4~dfsg.
  * Switch to compat level 10.
  * Drop -dbg package and use the automatic dbgsym package instead.
  * Vcs-Browser: Use https.
  * Declare compliance with Debian Policy 3.9.8.
  * Add clean file and ensure that atanks can be built twice in a row.
  * Update d/copyright for new release.

 -- Markus Koschany <apo@debian.org>  Sat, 01 Oct 2016 21:02:41 +0200

=== debian/control ===
Source: atanks
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 debhelper (>= 10),
 liballegro-dev | liballegro4.2-dev
Homepage: http://atanks.sourceforge.net/
Vcs-Git: https://anonscm.debian.org/pkg-games/atanks.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/atanks.git
Standards-Version: 3.9.8

Package: atanks
Architecture: any
Depends:
 atanks-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 atanks-data(<< 5.7~dfsg-1)
Breaks:
 atanks-data (<< 5.7~dfsg-1)
Description: tank-battling game
 Atomic tanks is a multi-player game in which you attempt to destroy
 other tanks while trying to protect your own. You earn money for
 destroying other tanks; with this money you can buy upgrades and better
 weapons for your tank.
 .
 This game is similar Scorched Earth or the Worms series of games.

Package: atanks-data
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Architecture: all
Description: data files for Atomic tanks
 Atomic tanks is a multi-player game in which you attempt to destroy
 other tanks while trying to protect your own. You earn money for
 destroying other tanks; with this money you can buy upgrades and better
 weapons for your tank.
 .
 This game is similar Scorched Earth or the Worms series of games.
 .
 This package holds the data files needed for Atomic tanks.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 DEBVERSION := $(shell head -n 1 debian/changelog \
                     | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
-UPVERSION := $(shell echo $(DEBVERSION) | sed 's/~dfsg-.//')
+UPVERSION := $(shell echo $(DEBVERSION) | sed 's/+dfsg-.//')
 
 PKG=atanks
 FILENAME := $(PKG)_$(UPVERSION)~dfsg.orig.tar.gz
@@ -10,7 +10,7 @@
 URL := http://downloads.sourceforge.net/project/$(PKG)/$(PKG)/$(PKG)-$(UPVERSION)/$(PKG)-$(UPVERSION).tar.gz
 
 %:
-	dh $@ --parallel --dbg-package=atanks-dbg
+	dh $@
 
 override_dh_install:
 	dh_install -XCOPYING --fail-missing

=== debian/watch ===
version=3
opts=dversionmangle=s/.dfsg// \
   http://sf.net/atanks/atanks-(.*)\.tar\.(?:gz|bz2) debian svn-upgrade

## atanks 6.6~dfsg

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 .PHONY: all install clean veryclean user winuser osxuser ubuntu \
 dist tarball zipfile source-dist i686-dist win32-dist
 
-VERSION := 6.5
+VERSION := 6.6
 
 
 DEBUG   ?= NO
@@ -302,6 +302,8 @@
 install: $(TARGET)
 	$(INSTALL) -d $(DESTDIR)${BINDIR}
 	$(INSTALL) -m 755 atanks $(DESTDIR)${BINDIR}
+	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/metainfo
+	$(INSTALL) -m 644 io.sourceforge.atanks.metainfo.xml $(DESTDIR)$(PREFIX)/share/metainfo
 	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/applications
 	$(INSTALL) -m 644 atanks.desktop $(DESTDIR)$(PREFIX)/share/applications
 	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps
@@ -358,10 +360,10 @@
 dist: source-dist i686-dist win32-dist
 
 tarball: veryclean
-	cd .. && tar czf $(FILENAME).tar.gz $(FILENAME) --exclude=.git
+	cd .. && tar --create --file $(FILENAME).tar.gz --auto-compress --exclude-vcs $(FILENAME) 
 
 zipfile: veryclean
-	cd .. && zip -r $(FILENAME)-source.zip $(FILENAME) -x *.git*
+	cd .. && zip -r $(FILENAME)-source.zip $(FILENAME) -x '*.git*'
 
 source-dist: $(TARGET)
 	cd ../; \

=== debian/changelog ===
atanks (6.6~dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:25:11 +1100

atanks (6.6~dfsg-1build1) noble; urgency=high

  * No change rebuild against liballegro4.4t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:29:25 +0100

atanks (6.6~dfsg-1) unstable; urgency=medium

  * New upstream version 6.6~dfsg.
  * Declare compliance with Debian Policy 4.6.0.
  * d/control: remove obsolete Breaks and Replaces.
  * Drop freebsd-hurd.patch. Fixed upstream.

 -- Markus Koschany <apo@debian.org>  Thu, 02 Sep 2021 08:33:07 +0200

atanks (6.5~dfsg-4) unstable; urgency=medium

  * Switch to debhelper-compat = 13.
  * Declare compliance with Debian Policy 4.5.0.

 -- Markus Koschany <apo@debian.org>  Sat, 14 Nov 2020 22:29:30 +0100

atanks (6.5~dfsg-3) unstable; urgency=medium

  * Switch to compat level 11.
  * Declare compliance with Debian Policy 4.2.1.
  * Use dh_missing --fail-missing instead of dh_install.
  * Drop deprecated menu file.
  * Remove obsolete README.source file.
  * Use https for Format field.
  * Use https for watch file URI.
  * Improve freebsd-hurd.patch and build atanks on GNU/Hurd and kFreeBSD.
    (Closes: #845924)
  * Use canonical VCS-URI.

 -- Markus Koschany <apo@debian.org>  Sun, 09 Dec 2018 17:27:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: atanks
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Markus Koschany <apo@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper-compat (= 13),
  liballegro-dev | liballegro4.2-dev
 Homepage: http://atanks.sourceforge.net/
-Vcs-Git: https://anonscm.debian.org/pkg-games/atanks.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/atanks.git
-Standards-Version: 3.9.8
+Vcs-Git: https://salsa.debian.org/games-team/atanks.git
+Vcs-Browser: https://salsa.debian.org/games-team/atanks
+Standards-Version: 4.6.0
 
 Package: atanks
 Architecture: any
@@ -18,10 +19,6 @@
  atanks-data (= ${source:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
-Replaces:
- atanks-data(<< 5.7~dfsg-1)
-Breaks:
- atanks-data (<< 5.7~dfsg-1)
 Description: tank-battling game
  Atomic tanks is a multi-player game in which you attempt to destroy
  other tanks while trying to protect your own. You earn money for

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 DEBVERSION := $(shell head -n 1 debian/changelog \
                     | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
-UPVERSION := $(shell echo $(DEBVERSION) | sed 's/+dfsg-.//')
+UPVERSION := $(shell echo $(DEBVERSION) | sed 's/~dfsg-.//')
 
 PKG=atanks
 FILENAME := $(PKG)_$(UPVERSION)~dfsg.orig.tar.gz
@@ -13,7 +13,7 @@
 	dh $@
 
 override_dh_install:
-	dh_install -XCOPYING --fail-missing
+	dh_install -XCOPYING
 	rm -fR $(CURDIR)/debian/atanks-data/usr/share/applications/
 
 get-orig-source:
